SystemOrganization addCategory: #'Neo-JSON-Core'!

!Collection methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/3/2012 19:29'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeList: self! !

!Number methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/2/2012 22:17'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeFloat: self asFloat! !

!Dictionary methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/3/2012 19:30'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeMap: self! !

!UndefinedObject methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/2/2012 22:15'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeNull! !

!SmallDictionary methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/3/2012 19:30'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeMap: self! !

!Integer methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/2/2012 22:17'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeInteger: self! !

!Boolean methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/2/2012 22:14'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeBoolean: self! !

Object subclass: #NeoJSONCompositeMapping
	instanceVariableNames: 'schemaName collectionClass elementSchema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONCompositeMapping commentStamp: 'SvenVanCaekenberghe 6/7/2012 22:02' prior: 0!
I am NeoJSONCompositeSchema.
I describe how a collection with elements conforming to a schema should be parsed.
!

!NeoJSONCompositeMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 22:31'!
collectionClass: smalltalkClass
	collectionClass := smalltalkClass! !

!NeoJSONCompositeMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 22:31'!
elementSchema: schema
	elementSchema := schema! !

!NeoJSONCompositeMapping methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/7/2012 22:02'!
printOn: stream
	super printOn: stream..
	stream nextPut: $(; print: schemaName; nextPut: $)! !

!NeoJSONCompositeMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 22:32'!
schemaName: schema
	schemaName := schema! !

NeoJSONCompositeMapping subclass: #NeoJSONListMapping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONListMapping commentStamp: 'SvenVanCaekenberghe 6/8/2012 13:53' prior: 0!
I am NeoJSONListMapping.
I am a NeoJSONCompositeMapping.

I parse a JSON list.!

!NeoJSONListMapping methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/8/2012 13:57'!
readFrom: jsonReader
	^ (collectionClass ifNil: [ jsonReader listClass ]) 
		streamContents: [ :stream |
			jsonReader parseListDo: [ | element |
				element := jsonReader nextAs: elementSchema.
				stream nextPut: element ] ]! !

NeoJSONCompositeMapping subclass: #NeoJSONMapMapping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONMapMapping commentStamp: 'SvenVanCaekenberghe 6/8/2012 13:54' prior: 0!
I am NeoJSONMapMapping.
I am a NeoJSONCompositeMapping.

I parse a JSON map.!

!NeoJSONMapMapping methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/8/2012 13:59'!
readFrom: jsonReader
	| map |
	map := (collectionClass ifNil: [ jsonReader mapClass ]) new.
	jsonReader parseMapKeysDo: [ :key | | element |
		element := jsonReader nextAs: elementSchema.
		map at: key put: element ].
	^ map! !

Object subclass: #NeoJSONCustomMapping
	instanceVariableNames: 'schemaName reader writer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONCustomMapping commentStamp: '<historical>' prior: 0!
I am NeoJSONCustomMapping.

I read the next JSON value and turn it into a Smalltalk object using a converter block.!

!NeoJSONCustomMapping methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/8/2012 21:09'!
printOn: stream
	super printOn: stream..
	stream nextPut: $(; print: schemaName; nextPut: $)! !

!NeoJSONCustomMapping methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/8/2012 21:41'!
readFrom: jsonReader
	| representation |
	representation := jsonReader next.
	^ reader value: representation! !

!NeoJSONCustomMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/8/2012 21:39'!
reader: block
	reader := block! !

!NeoJSONCustomMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/8/2012 21:09'!
schemaName: schema
	schemaName := schema! !

!NeoJSONCustomMapping methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/8/2012 21:42'!
writeObject: anObject on: jsonWriter
	| representation |
	representation := writer value: anObject.
	jsonWriter nextPut: representation ! !

!NeoJSONCustomMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/8/2012 21:39'!
writer: block
	writer := block! !

Object subclass: #NeoJSONMapper
	instanceVariableNames: 'mappings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONMapper commentStamp: 'SvenVanCaekenberghe 6/8/2012 09:37' prior: 0!
I am NeoJSONMapper.
I hold a mapping from schema identifiers to object that known how to read or write instances to or from JSON.

Schema identifiers are either Smalltalk classes or Symbols.
!

!NeoJSONMapper methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/8/2012 14:04'!
for: smalltalkClass do: block
	| mapping |
	mapping := self newObjectMappingFor: smalltalkClass.
	block value: mapping! !

!NeoJSONMapper methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/8/2012 21:12'!
forCustom: schemaName do: block
	| mapping |
	mapping := self newCustomMappingFor: schemaName.
	block value: mapping! !

!NeoJSONMapper methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/8/2012 14:11'!
forList: schemaName do: block
	| mapping |
	mapping := self newListMappingFor: schemaName.
	block value: mapping! !

!NeoJSONMapper methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/8/2012 14:12'!
forMap: schemaName do: block
	| mapping |
	mapping := self newMapMappingFor: schemaName.
	block value: mapping! !

!NeoJSONMapper methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 6/8/2012 14:01'!
mapAllInstVarsFor: smalltalkClass
	| mapping |
	mapping := self newObjectMappingFor: smalltalkClass.
	mapping mapAllInstVars! !

!NeoJSONMapper methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 6/8/2012 14:02'!
mapInstVarsFor: smalltalkClass
	| mapping |
	mapping := self newObjectMappingFor: smalltalkClass.
	mapping mapInstVars! !

!NeoJSONMapper methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 15:55'!
mappingFor: schema
	^ self 
		mappingFor: schema 
		ifAbsent: [ self error: 'No mapping found for: ', schema printString ]! !

!NeoJSONMapper methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 6/8/2012 14:02'!
mappingFor: smalltalkClass do: block
	| mapping |
	mapping := self newObjectMappingFor: smalltalkClass.
	block value: mapping! !

!NeoJSONMapper methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/9/2012 18:24'!
mappingFor: schema ifAbsent: block
	(self mappings includesKey: schema)
		ifFalse: [ self resolveMappingFor: schema ].
	^ self mappings
		at: schema
		ifAbsent: block! !

!NeoJSONMapper methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/7/2012 14:55'!
mappings
	^ mappings
		ifNil: [ mappings := Dictionary new ]! !

!NeoJSONMapper methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/8/2012 21:12'!
newCustomMappingFor: schemaName
	| mapping |
	mapping := NeoJSONCustomMapping new.
	mapping schemaName: schemaName.
	self mappings at: schemaName put: mapping.
	^ mapping! !

!NeoJSONMapper methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/8/2012 14:13'!
newListMappingFor: schemaName
	| mapping |
	mapping := NeoJSONListMapping new.
	mapping schemaName: schemaName.
	self mappings at: schemaName put: mapping.
	^ mapping! !

!NeoJSONMapper methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/8/2012 14:13'!
newMapMappingFor: schemaName
	| mapping |
	mapping := NeoJSONMapMapping new.
	mapping schemaName: schemaName.
	self mappings at: schemaName put: mapping.
	^ mapping! !

!NeoJSONMapper methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/8/2012 14:13'!
newObjectMappingFor: smalltalkClass
	| mapping |
	mapping := NeoJSONObjectMapping new.
	mapping subjectClass: smalltalkClass.
	self mappings at: smalltalkClass put: mapping.
	^ mapping! !

!NeoJSONMapper methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/9/2012 18:29'!
resolveMappingFor: class
	(class respondsTo: #neoJsonMapping:)
		ifTrue: [ 
			class perform: #neoJsonMapping: with: self ]! !

NeoJSONMapper subclass: #NeoJSONReader
	instanceVariableNames: 'readStream stringStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONReader commentStamp: 'SvenVanCaekenberghe 6/6/2012 15:24' prior: 0!
I am NeoJSONReader.
I parse a JSON representation from a textual stream into Smalltalk object(s).

Primitive types are automatically mapped to their Smalltalk counterpart: Numbers, Strings, Booleans and UndefinedObject.
When parsing using #next, lists normally become Arrays and maps become Dictionaries.
An alternative listClass or mapClass can be specified.

When parsing using #nextAs: a schema can be specified.!

!NeoJSONReader class methodsFor: 'convenience' stamp: 'SvenVanCaekenberghe 6/9/2012 18:26'!
fromString: string
	^ (self on: string readStream) next! !

!NeoJSONReader class methodsFor: 'convenience' stamp: 'SvenVanCaekenberghe 6/9/2012 18:30'!
fromString: string as: schema
	^ (self on: string readStream) nextAs: schema! !

!NeoJSONReader class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 6/2/2012 14:03'!
on: readStream
	^ self new
		on: readStream;
		yourself! !

!NeoJSONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/2/2012 13:50'!
close
	readStream ifNotNil: [
		readStream close.
		readStream := nil ]! !

!NeoJSONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/2/2012 21:26'!
consumeWhitespace
	"Strip whitespaces from the input stream."

	[ readStream atEnd not and: [ readStream peek isSeparator ] ]
		whileTrue: [ 
			readStream next ]! !

!NeoJSONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/2/2012 14:01'!
expectChar: character
	"Expect character and consume input and optional whitespace at the end,
	 throw an error otherwise."

	(self matchChar: character)
		ifFalse: [ self error: character asString, ' expected' ]! !

!NeoJSONReader methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 16:57'!
listClass
	"Return the collection type to use for JSON lists"
	
	^ Array! !

!NeoJSONReader methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 16:58'!
mapClass
	"Return the collection type to use for JSON maps"
	
	^ Dictionary! !

!NeoJSONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/6/2012 20:18'!
match: string do: block
	"Try to read and consume string and execute block if successful.
	Else do nothing (but do not back up)"
	 
	(string allSatisfy: [ :each | self matchChar: each ] )
		ifTrue: block value
! !

!NeoJSONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/4/2012 14:40'!
matchChar: character
	"Tries to match character, consume input and 
	answer true if successful and consumes whitespace at the end.
	When character does not match, return false and leave stream untouched."
	
	^ readStream peek = character
		ifTrue: [
			readStream next.
			self consumeWhitespace.
			true ]
		ifFalse: [
			false ]! !

!NeoJSONReader methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 16:56'!
next
	"Primary interface to parse a JSON value.
	Return either primitives, a listClass or a mapClass instance."
	
	^ self 
		consumeWhitespace; 
		parseValue! !

!NeoJSONReader methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 22:21'!
nextAs: schema
	"Secondary interface to parse JSON.
	Return objects according to schema."
	
	| mapping |
	schema ifNil: [ ^ self next ].
	self consumeWhitespace.
	mapping := self mappingFor: schema.
	^ mapping readFrom: self! !

!NeoJSONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/2/2012 13:50'!
on: aReadStream
	readStream := aReadStream! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 16:59'!
parseCharacter
	| char |
	(char := readStream next) = $\ 
		ifFalse: [ ^ char ].
	('/"\' includes: (char := readStream next))
		ifTrue: [ ^ char ].
	('bfnrt' includes: char)
		ifTrue: [ ^ self unescapeChar: char ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 14:20'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ 
		value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 14:21'!
parseCharacterHexDigit
	| digit |
	readStream atEnd 
		ifFalse: [ 
			digit := readStream next asInteger.
			(digit between: "$0" 48 and: "$9" 57)
				ifTrue: [ ^ digit - 48 ].
			(digit between: "$A" 65 and: "$F" 70)
				ifTrue: [ ^ digit - 55 ].
			(digit between: "$a" 97 and: "$f" 102)
				ifTrue: [ ^ digit - 87 ] ].
	self error: 'hex-digit expected'! !

!NeoJSONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/2/2012 14:16'!
parseConstantDo: block
	"Parse and consume either true|false|nil|null and execute block 
	or else do nothing (but do not back up).
	Hand written implementation to avoid the use of #position:"
	
	(readStream peek = $t)
		ifTrue: [
			^ self match: 'true' do: [ block value: true ] ].
	(readStream peek = $f)
		ifTrue: [
			^ self match: 'false' do: [ block value: false ] ].
	(readStream peek = $n)
		ifTrue: [
			^ self match: 'null' do: [ block value: nil ] ]
! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 17:17'!
parseList
	^ self listClass 
		streamContents: [ :stream |
			self parseListElementsDo: [ :each |
				stream nextPut: each ] ]

		! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 17:15'!
parseListDo: block
	self expectChar: $[.
	(self matchChar: $]) 
		ifTrue: [ ^ self ].
	[ readStream atEnd ] 
		whileFalse: [
			block value.
			(self matchChar: $]) 
				ifTrue: [ ^ self ].
			self expectChar: $, ].
	self error: 'end of list expected'! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 17:16'!
parseListElementsDo: block
	self parseListDo: [ 
		block value: self parseValue ]! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 17:23'!
parseMap
	| map |
	map := self mapClass new.
	self parseMapKeysAndValuesDo: [ :key :value |
		map at: key put: value ].
	^ map! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 17:23'!
parseMapDo: block
	self expectChar: ${.
	(self matchChar: $})
		ifTrue: [ ^ self ].
	[ readStream atEnd ] whileFalse: [
		block value.
		(self matchChar: $}) 
			ifTrue: [ ^ self ].
		self expectChar: $, ].
	self error: 'end of map expected'! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 17:22'!
parseMapKeysAndValuesDo: block
	self parseMapKeysDo: [ :key |
		block value: key value: self parseValue ]! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/7/2012 17:23'!
parseMapKeysDo: block
	self parseMapDo: [ | key |
		key := self parsePropertyName.
		self expectChar: $:.
		block value: key ]! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 21:50'!
parseNumber
	| negated number |
	(negated := readStream peek = $-)
		ifTrue: [ readStream next ].
	number := self parseNumberInteger.
	(readStream peek = $.) 
		ifTrue: [
			readStream next. 
			number := number + self parseNumberFraction ].
	(readStream peek = $e or: [ readStream peek = $E ]) 
		ifTrue: [
			readStream next.
			number := number * self parseNumberExponent ].
	negated 
		ifTrue: [ number := number negated ].
	self consumeWhitespace.
	^ number! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 13:59'!
parseNumberExponent
	| number negated |
	number := 0.
	negated := readStream peek = $-.
	(negated or: [ readStream peek = $+ ]) 
		ifTrue: [ readStream next ].
	[ readStream atEnd not and: [ readStream peek isDigit ] ] 
		whileTrue: [ 
			number := 10 * number + readStream next digitValue ].
	negated 
		ifTrue: [ number := number negated ].
	^ 10 raisedTo: number! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 14:00'!
parseNumberFraction
	| number power |
	number := 0.
	power := 1.0.
	[ readStream atEnd not and: [ readStream peek isDigit ] ] 
		whileTrue: [
			number := 10 * number + readStream next digitValue.
			power := power * 10.0 ].
	^ number / power! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 14:00'!
parseNumberInteger
	| number |
	number := 0.
	[ readStream atEnd not and: [ readStream peek isDigit ] ] 
		whileTrue: [ 
			number := 10 * number + readStream next digitValue ].
	^ number! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 21:58'!
parsePropertyName
	| name |
	name := self parseValue.
	^ name isString
		ifTrue: [ name ]
		ifFalse: [ self error: 'property name must be string' ]! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 13:58'!
parseString
	| result |
	self expectChar: $".
	result := self stringStreamContents: [ :stream |
		[ readStream atEnd or: [ readStream peek = $"] ] 
			whileFalse: [ 
				stream nextPut: self parseCharacter ] ].
	self expectChar: $".
	^ result! !

!NeoJSONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/2/2012 13:55'!
parseValue
	| char |
	readStream atEnd ifFalse: [ 
		char := readStream peek.
		char = ${
			ifTrue: [ ^ self parseMap ].
		char = $[
			ifTrue: [ ^ self parseList ].
		char = $"
			ifTrue: [ ^ self parseString ].
		(char = $- or: [ char isDigit ])
			ifTrue: [ ^ self parseNumber ].
		self parseConstantDo: [ :value | ^ value ] ].
	self error: 'invalid input'! !

!NeoJSONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/7/2012 16:54'!
stringStreamContents: block
	"Like String streamContents: block
	but reusing the underlying buffer for improved efficiency"
	
	stringStream 
		ifNil: [ 
			stringStream := (String new: 32) writeStream ].
	stringStream reset.
	block value: stringStream.
	^ stringStream contents! !

!NeoJSONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/7/2012 16:55'!
unescapeChar: char
	"Handle one of the named character escapes, b, f, n, r or t. Else fail."
	
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	self error: 'Unknown escape char: ', (String with: char)! !

NeoJSONMapper subclass: #NeoJSONWriter
	instanceVariableNames: 'writeStream prettyPrint level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONWriter commentStamp: 'SvenVanCaekenberghe 6/6/2012 15:23' prior: 0!
I am NeoJSONWriter.
I write a JSON representation of a Smalltalk object(s) on to textual stream.

Objects implementing #neoJsonOn: can be encoded.
A number of primitive types, like Strings, Numbers, Booleans and UndefinedObject are treated specially.
Collection are encoded as lists, except for Dictionaries that are encoded as maps.

All other objects need a mapping.!

!NeoJSONWriter class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 6/2/2012 22:06'!
on: writeStream
	^ self new
		on: writeStream;
		yourself! !

!NeoJSONWriter class methodsFor: 'convenience' stamp: 'SvenVanCaekenberghe 6/9/2012 18:27'!
toString: object
	^ String streamContents: [ :stream |
			(self on: stream) nextPut: object ]! !

!NeoJSONWriter class methodsFor: 'convenience' stamp: 'SvenVanCaekenberghe 6/9/2012 18:28'!
toStringPretty: object
	^ String streamContents: [ :stream |
			(self on: stream)
				prettyPrint: true; 
				nextPut: object ]! !

!NeoJSONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/2/2012 22:06'!
close
	writeStream ifNotNil: [
		writeStream close.
		writeStream := nil ]! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/10/2012 21:16'!
encodeChar: char
	| code |
	code := char codePoint.
	(code < 32 or: [ code = 34 or: [ code = 92 ] ])
		ifTrue: [ self escapeChar: code ]
		ifFalse: [ writeStream nextPut: char ]! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/3/2012 19:41'!
encodeKey: key value: value
	self nextPut: key.
	self prettyPrintSpace.
	writeStream nextPut: $:.
	self prettyPrintSpace.
	self nextPut: value! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/2/2012 22:45'!
escapeChar: code
	code = 34
		ifTrue: [ ^ writeStream nextPutAll: '\"' ].
	code = 92
		ifTrue: [ ^ writeStream nextPutAll: '\\' ].
	code = 47
		ifTrue: [ ^ writeStream nextPutAll: '\/' ].
	code = 8
		ifTrue: [ ^ writeStream nextPutAll: '\b' ].
	code = 12
		ifTrue: [ ^ writeStream nextPutAll: '\f' ].		
	code = 10
		ifTrue: [ ^ writeStream nextPutAll: '\n' ].		
	code = 13
		ifTrue: [ ^ writeStream nextPutAll: '\r' ].		
	code = 9
		ifTrue: [ ^ writeStream nextPutAll: '\t' ].		
	writeStream nextPutAll: '\u'.
	code printOn: writeStream base: 16 nDigits: 4! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/3/2012 19:31'!
indentedDo: block
	level := level + 1.
	block value.
	level := level - 1! !

!NeoJSONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/2/2012 22:07'!
initialize
	super initialize.
	prettyPrint := false.
	level := 0! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/3/2012 19:32'!
listElementSeparator
	writeStream nextPut: $,.
	self newlineIndent
! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/3/2012 19:32'!
mapElementSeparator
	writeStream nextPut: $,.
	self newlineIndent
! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/5/2012 22:45'!
mappings
	^ mappings
		ifNil: [ mappings := Dictionary new ]! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/3/2012 19:34'!
newlineIndent
	prettyPrint
		ifTrue: [ 
			writeStream nextPut: Character cr.
			level timesRepeat: [ writeStream tab ] ]! !

!NeoJSONWriter methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/2/2012 22:11'!
nextPut: anObject
	anObject neoJsonOn: self! !

!NeoJSONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/2/2012 22:06'!
on: aWriteStream
	writeStream := aWriteStream
! !

!NeoJSONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/2/2012 22:06'!
prettyPrint: boolean
	prettyPrint := boolean! !

!NeoJSONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 6/3/2012 19:34'!
prettyPrintSpace
	prettyPrint
		ifTrue: [ writeStream space ]
! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/2/2012 22:18'!
writeBoolean: boolean
	boolean printOn: writeStream! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/2/2012 22:19'!
writeFloat: float
	float printOn: writeStream! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/2/2012 22:18'!
writeInteger: integer
	integer printOn: writeStream
	! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:20'!
writeList: collection
	self writeListStreamingDo: [ :jsonListWriter |
		collection do: [ :each |
			jsonListWriter writeElement: each ] ]! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:19'!
writeListStreamingDo: block
	writeStream nextPut: $[.
	self writeStreamingDo: block.
	writeStream nextPut: $]! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:04'!
writeMap: keyValueCollection
	self writeMapStreamingDo: [ :jsonMapWriter |
		keyValueCollection keysAndValuesDo: [ :key :value |
			jsonMapWriter writeKey: key value: value ] ]! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:19'!
writeMapStreamingDo: block
	writeStream nextPut: ${.
	self writeStreamingDo: block.
	writeStream nextPut: $}! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/2/2012 22:15'!
writeNull
	writeStream nextPutAll: 'null'! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/7/2012 15:55'!
writeObject: anObject
	| mapping |
	mapping := self mappingFor: anObject class.
	mapping
		writeObject: anObject
		on: self! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:19'!
writeStreamingDo: block
	| mapWriter |
	mapWriter := NeoJSONStreamingWriter on: self.
	self indentedDo: [
		block value: mapWriter ].
	mapWriter wasUsed
		ifTrue: [ self newlineIndent ]
		ifFalse: [ self prettyPrintSpace ]! !

!NeoJSONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/3/2012 19:42'!
writeString: string
	writeStream nextPut: $".
	string do: [ :each |
		self encodeChar: each ].
	writeStream nextPut: $"! !

Object subclass: #NeoJSONObjectMapping
	instanceVariableNames: 'subjectClass properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONObjectMapping commentStamp: 'SvenVanCaekenberghe 6/5/2012 22:47' prior: 0!
I am NeoJSONObjectMapping.
I describe how instances of a Smalltalk class are mapped to a JSON map.

I do this using set of NeoJSONPropertyMappings.!

!NeoJSONObjectMapping methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/5/2012 22:50'!
initialize
	super initialize.
	properties := Dictionary new.! !

!NeoJSONObjectMapping methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/6/2012 16:00'!
mapAllInstVars
	self mapInstVars: subjectClass allInstVarNames! !

!NeoJSONObjectMapping methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/9/2012 18:37'!
mapInstVar: instVarName
	^ self mapInstVar: instVarName to: instVarName ! !

!NeoJSONObjectMapping methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/9/2012 18:36'!
mapInstVar: instVarName to: propertyName
	| index |
	index := subjectClass 
		instVarIndexFor: instVarName 
		ifAbsent: [ self error: 'Inst var not found: ', instVarName printString ].
	^ self 
		mapProperty: propertyName
		getter: [ :object | object instVarAt: index ]
		setter: [ :object :value | object instVarAt: index put: value ] ! !

!NeoJSONObjectMapping methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/6/2012 15:59'!
mapInstVars
	self mapInstVars: subjectClass instVarNames! !

!NeoJSONObjectMapping methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/6/2012 16:00'!
mapInstVars: instVarNames
	instVarNames do: [ :each |
		self mapInstVar: each ]! !

!NeoJSONObjectMapping methodsFor: 'mapping' stamp: 'SvenVanCaekenberghe 6/9/2012 18:13'!
mapProperty: propertyName getter: readBlock setter: writeBlock
	| propertyMapping |
	propertyMapping := NeoJSONPropertyMapping new.
	propertyMapping 
		propertyName: propertyName;
		getter: readBlock;
		setter: writeBlock.
	properties at: propertyName put: propertyMapping.
	^ propertyMapping ! !

!NeoJSONObjectMapping methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/7/2012 15:30'!
printOn: stream
	super printOn: stream..
	stream nextPut: $(; print: subjectClass; nextPut: $)! !

!NeoJSONObjectMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/7/2012 14:52'!
propertyNamed: propertyName ifAbsent: block
	^ properties at: propertyName ifAbsent: block! !

!NeoJSONObjectMapping methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/8/2012 17:13'!
readFrom: jsonReader
	| anObject |
	anObject := subjectClass new.
	jsonReader parseMapKeysDo: [ :key |
		(self propertyNamed: key ifAbsent: [ nil ])
			ifNil: [
				"read, skip & ignore value"
				jsonReader next ]
			ifNotNil: [ :mapping |
				mapping readObject: anObject from: jsonReader ] ].
	^ anObject! !

!NeoJSONObjectMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:32'!
subjectClass: smalltalkClass
	subjectClass := smalltalkClass! !

!NeoJSONObjectMapping methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 14:55'!
writeObject: anObject on: jsonWriter
	jsonWriter writeMapStreamingDo: [ :jsonMapWriter |
		properties valuesDo: [ :each |
			each writeObject: anObject on: jsonMapWriter ] ]! !

Object subclass: #NeoJSONPropertyMapping
	instanceVariableNames: 'propertyName valueSchema getter setter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONPropertyMapping commentStamp: 'SvenVanCaekenberghe 6/6/2012 15:34' prior: 0!
I am NeoJSONPropertyMapping.
I describe how a property of a Smalltalk class maps to a JSON property.

A property is either an instance variable or getter/setter pair.
I hold a getter and setter block to do the actual work.!

!NeoJSONPropertyMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:34'!
getter: block
	getter := block! !

!NeoJSONPropertyMapping methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 6/7/2012 15:30'!
printOn: stream
	super printOn: stream..
	stream nextPut: $(; print: propertyName; nextPut: $)! !

!NeoJSONPropertyMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:34'!
propertyName: string
	propertyName := string! !

!NeoJSONPropertyMapping methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 6/8/2012 17:04'!
readObject: anObject from: jsonReader
	| value |
	value := jsonReader nextAs: valueSchema.
	setter value: anObject value: value! !

!NeoJSONPropertyMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:34'!
setter: block
	setter := block! !

!NeoJSONPropertyMapping methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 6/8/2012 17:01'!
valueSchema: schemaName
	valueSchema := schemaName! !

!NeoJSONPropertyMapping methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 14:54'!
writeObject: anObject on: jsonMapWriter
	| value |
	value := getter value: anObject.
	value 
		ifNotNil: [ jsonMapWriter writeKey: propertyName value: value ] ! !

Object subclass: #NeoJSONStreamingWriter
	instanceVariableNames: 'jsonWriter first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo-JSON-Core'!

!NeoJSONStreamingWriter commentStamp: 'SvenVanCaekenberghe 6/6/2012 15:13' prior: 0!
I am NeoJSONStreamingWriter.
I help in writing streamed maps and lists.!

!NeoJSONStreamingWriter class methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 6/6/2012 15:05'!
on: jsonWriter
	^ self new
		on: jsonWriter;
		yourself! !

!NeoJSONStreamingWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/6/2012 14:48'!
initialize
	super initialize.
	first := true! !

!NeoJSONStreamingWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 6/6/2012 14:49'!
on: aJSONWriter
	jsonWriter := aJSONWriter! !

!NeoJSONStreamingWriter methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:00'!
wasUsed
	^ first not! !

!NeoJSONStreamingWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:15'!
writeElement: value
	first 
		ifTrue: [ 
			jsonWriter newlineIndent. 
			first := false ]
		ifFalse: [ 
			jsonWriter listElementSeparator ].
	jsonWriter nextPut: value ! !

!NeoJSONStreamingWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 6/6/2012 15:01'!
writeKey: key value: value
	first 
		ifTrue: [ 
			jsonWriter newlineIndent. 
			first := false ]
		ifFalse: [ 
			jsonWriter mapElementSeparator ].
	jsonWriter encodeKey: key value: value ! !

!Object methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/5/2012 22:29'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeObject: self! !

!String methodsFor: '*neo-json-core' stamp: 'SvenVanCaekenberghe 6/2/2012 22:26'!
neoJsonOn: neoJSONWriter
	neoJSONWriter writeString: self! !
